%% Sorpce1 verse 1.08
%% Filtrace namench dat pomoc Butterworthova filtru
clc, close all, clear all
global t qo q qs No N L
global i1 i2;

%% Pehled dat
% to, qo, No ... originln namen data
% t , q , No  ... upraven namen data
% ti, qi, Ni ... ekvidistantn interpolovan data
% ti, qf, Ni ... ekvidistantn filtrovan data
% to, qs, No ... zptn pevzorkovan data
% to, qa, N ... data vypoten z modelu

%% Naten experimentlnch dat
vstup = menu('Volba typu datovch soubor',...
    'Textov soubor s hodnotami oddlenmi oddlovaem - *.csv',...
    'Seit aplikace MS Excel - *.xls');
close(gcf)
if vstup < 1 || vstup > 2
    vstup = 1;
end
datsoubor = input('Zadejte jmno datovho souboru: ','s');
[pathstr, name, ext] = fileparts(datsoubor);
switch vstup
    case 1
        if strcmp(ext,'')
            datsoubor = [datsoubor,'.csv'];
        else
            if ~strcmp(ext,'.csv')
                datsoubor = strrep(datsoubor,ext,'.csv');
            end
        end
    case 2
        if strcmp(ext,'')
            datsoubor = [datsoubor,'.xls'];
        else
            if ~strcmp(ext,'.xls')
                datsoubor = strrep(datsoubor,ext,'.xls');
            end
        end
end
fid = fopen(datsoubor);
if fid < 0
    disp(' ')
    disp(['Soubor ',datsoubor,' pracovn sloce neexistuje!!!'])
    disp(' ')
    return
end
switch vstup
    case 1
        oddelovac = menu(['Vbr oddlovae hodnot v souboru ',datsoubor],'Stednk','rka');
        switch oddelovac
            case 1
                delimiter = ';';
            case 2
                delimiter = ',';
        end
        close(gcf)
        disp(' ')
        disp('Probh ten dat ze vstupnho textovho souboru!!!')
        disp(' ')
        data = textscan(fid,'%f %f %f','delimiter',delimiter);
        fclose(fid);
        to = data{1};
        qo = data{2};
        po = data{3};
        No = length(to);
        disp(['Peteno ', num2str(No), ' dk!'])
        disp(' ')
        if No == 0
            disp(['Datov soubor ', datsoubor, ' je przdn!!!'])
            disp(' ')
            return
        end
        xlsdatsoubor = strrep(datsoubor,'csv','xls');
    case 2
        fclose(fid);
        data = xlsread(datsoubor)
        if isempty(data)
            disp(['Datov soubor ', datsoubor, ' je przdn ', ...
                'nebo neobsahuje seln hodnoty!!!'])
            disp(' ')
            return
        end
        to = data(:,1);
        qo = data(:,2);
        po = data(:,3);
        No = length(to);
        disp(['Peteno ', num2str(No), ' dk!'])
        disp(' ')
        xlsdatsoubor = datsoubor;
end
disp(' ')
disp('Probh zpis dat do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
warning off MATLAB:xlswrite:AddSheet
[status, message] = xlswrite(xlsdatsoubor,...
    {'Time','Prolongation','Pressure';...
    '[s]','[mm]','[Pa]'},'Data','A1');
if strcmp(message.message,'Added specified worksheet.')
    disp(['Do souboru ', xlsdatsoubor, ' pidn list Data!!!'])
    disp(' ')
end
[status, message] = xlswrite(xlsdatsoubor,[to,po,qo],'Data','A3');
if status == 1
    disp(['Do souboru ', xlsdatsoubor, ' spn zapsno ', num2str(No), ' dk!!!'])
    disp(' ')
else
    disp(['Zpis dat do souboru ', xlsdatsoubor, ' nebyl spn!!!'])
    return
end

%% Fyzikln parametry membrny
% Tlouka membrny
L = input('Zadejte hodnotu tlouku membrny L [m] = ');
while ~isnumeric(L)
    disp('Zadan hodnota tlouky membrny L nen slo, opakuj!')
    L = input('Zadejte hodnotu tlouky membrny L [m] = ');
end

% Odhad difuznho koeficientu podle metody poloasu
Dx = 0.04919/to(find(abs(qo-mean(qo(end-100:end))/2)<=1e-2*mean(qo(end-100:end)),1,'first'))*L^2;
fprintf('Odhad difuznho koeficientu   : %10.4e [m2/s] \n',Dx)

%% Volba jazyka (1 - etina, 2 - anglitina)
jazyk = menu('Volba jazyka pro popis obrzk','etina','Anglitina');
close(gcf)

%% Zobrazen namench dat
figure(1), hold on, grid on
switch jazyk
    case 1
        title('Namen data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
plot(to,qo,'b')
pause

% zobrazen potku men
% redukce rozsahu dat
kk = 0.1;
figure(2), hold on, grid on
switch jazyk
    case 1
        title('Namen data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
plot(to(1:fix(kk*end)),qo(1:fix(kk*end)),'b')
kend = fix(kk*length(to));
pause

%% Uren periody vzorkovn
T = to(2:end)-to(1:end-1);
figure(3), hold on, grid on
% Vylouen peruen men
plot(T(T<mean(T) + 2*var(T)))
switch jazyk
    case 1
        title('Promnliv perioda vzorkovn')
        xlabel('as t [s]'), ylabel('Perioda vzorkovn T [s]')
    case 2
        title('Variable sampling period')
        xlabel('Time t [s]'), ylabel('Sampling period T [s]')
end
pause

%% Histogram interval men
% Obrzek . 4
figure(4), hold on, grid on

% Perioda vzorkovn
Ts = round(median(T)*10)/10;
Tgrp = 10^floor(log10(Ts));
hist(T,[floor(min(T)/Tgrp)*Tgrp:Tgrp:ceil(max(T)/Tgrp)*Tgrp]);
h = findobj(gca,'Type','patch');
set(h,'FaceColor','b')
[ycol,xcol]=hist(T,[floor(min(T)/Tgrp)*Tgrp:Tgrp:ceil(max(T)/Tgrp)*Tgrp]);
xshift = Tgrp/10;
YTicks = get(gca,'YTick');
yshift = (YTicks(2)-YTicks(1))/10;
for k = 1:length(xcol)
    text(xcol(k)-xshift*length(int2str(ycol(k)))/length(No)/4,...
        ycol(k)+yshift+50,['\bf',int2str(ycol(k))]);
end

switch jazyk
    case 1
        title('Histogram period vzorkovn')
        xlabel('Perioda vzorkovn T [s]')
        ylabel('Poet period vzorkovn')
    case 2
        title('Sampling period histogram')
        xlabel('Sampling period T [s]')
        ylabel('Number of sampling periods')
end
pause

%% Neekvidistantn data - pevzorkovan pomoc interpolace
toi = (ceil(to(1)/Ts)*Ts:Ts:floor(to(No)/Ts)*Ts)';
% interpolace signlu na ekvidistantn
qoi = interp1(to,qo,toi,'linear'); 
Noi = length(toi);

%% Odstrann stacionrn sloky signlu
value = zeros(Noi,1);
term = ones(Noi,1);
Qinf = mean(qoi(end-100:end));
k = 0;
while norm(term) > 1024*eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*Dx/L^2*toi)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qoa = Qinf*(1-8/pi^2*value);
qoid = qoi-qoa;
qoid = qoid-mean(qoid);

%% Diskrtn Fourierova transformace
NFFT = 2^nextpow2(Noi); % Next power of 2 from length of q
Qo = fft(qoid,NFFT)/Noi;
fo = 1/2/Ts*linspace(0,1,NFFT/2+1);

%  Frekvenn spektrum namench dat
figure(5), hold on, grid on
plot(fo,2*abs(Qo(1:NFFT/2+1))) 
switch jazyk
    case 1
        title('Amplitudov spektrum namench dat')
        xlabel('Frekvence [Hz]')
        ylabel('Amplituda')
    case 2
        title('Amplitude spectrum of measured data')
        xlabel('Frequency [Hz]')
        ylabel('Amplitude')
end
pause

%  Detailn frekvenn spektrum namench dat
figure(6), hold on, grid on
plot(fo,2*abs(Qo(1:NFFT/2+1))) 
xmax = 10^ceil(log10(fo(find(abs(Qo(11:NFFT/2+1)) == ...
    max(abs(Qo(11:NFFT/2+1)))))));
set(gca,'XLim',[0,xmax]);
switch jazyk
    case 1
        title('Amplitudov spektrum namench dat')
        xlabel('Frekvence [Hz]')
        ylabel('Amplituda')
    case 2
        title('Amplitude spectrum of measured data')
        xlabel('Frequency [Hz]')
        ylabel('Amplitude')
end
pause

%% Redukce dat - odstrann pulsu
t = to;
q = qo;
kk = 0.1;
kend = fix(kk*No);
imax=find(qo == max(qo(1:kend)));
di = 1;
i1 = imax-1;
i2 = imax;

figure(7), hold on, grid on
switch jazyk
    case 1
        title('Redukovan namen  data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Reduced measured data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
h1 = plot([to(1:i1);to(i2:kend)],[qo(1:i1);qo(i2:kend)],'b');
switch jazyk
    case 1
        h2 = text(0.10,0.95,...
            ['Doln mez = ',num2str(i1*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h3 = text(0.5,0.95,...
            ['Horn mez = ',num2str(i2*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h4 = text(0.10,0.90,...
            ['Krok = ',num2str(di*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
    case 2
        h2 = text(0.10,0.95,...
            ['Lower margin = ',num2str(i1*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h3 = text(0.5,0.95,...
            ['Upper margin = ',num2str(i2*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h4 = text(0.10,0.90,...
            ['Step = ',num2str(di*Ts),' [s]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
end
postup = 1;
while postup > 0
    postup = menu('Dal postup','Men doln mez','Vt doln mez',...
        'Vt horn mez','Men horn mez','Men krok','Vt krok','Bez korekce','Konec');
    switch postup
        case 1
            i1 = i1-di;
        case 2
            i1 = i1+di;
        case 3
            i2 = i2+di;
        case 4
            i2 = i2-di;
        case 5
            di = max(di-1,1);
        case 6
            di = di+1;
        case 7
            i1 = imax-1;
            i2 = imax;
        case 8
            postup = 0;
    end
    delete(h1);
    delete(h2);
    delete(h3);
    delete(h4);
    h1 = plot([t(1:i1);t(i2:kend)],[q(1:i1);q(i2:kend)],'b');
    switch jazyk
        case 1
            h2 = text(0.10,0.95,...
                ['Doln mez = ',num2str(i1*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.5,0.95,...
                ['Horn mez = ',num2str(i2*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.10,0.90,...
                ['Krok = ',num2str(di*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
        case 2
            h2 = text(0.10,0.95,...
                ['Lower margin = ',num2str(i1*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.5,0.95,...
                ['Upper margin = ',num2str(i2*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.10,0.90,...
                ['Step = ',num2str(di*Ts),' [s]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
    end
end

% linern interpolace
q = [q(1:i1);(q(i2)-q(i1))/(t(i2)-t(i1))*(t(i1+1:i2-1)-t(i1))+q(i1);q(i2:end)];
N = length(t);
postup = menu('Posun hodnot','Bez posunu','Do nuly','O prmr');
switch postup
    case 1
        posun = 0;
    case 2
        posun = q(1);
    case 3
        posun =  mean(q(q<0.01*max(q)));
end
q = q-posun;
delete(h1);

% odstrann stacionrn sloky signlu
value = zeros(N,1);
term = ones(N,1);
Qinf = mean(q(end-100:end));
k = 0;
while norm(term) > 1024*eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*Dx/L^2*t)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa = Qinf*(1-8/pi^2*value);
qd = q-qa;
qd = qd-mean(qd);
q(i1+1:i2-1) = q(i1+1:i2-1)+std(qd)*randn(size(to(i1+1:i2-1)));
h1 = plot(t(1:kend),q(1:kend),'b');

delete(h2)
delete(h3)
delete(h4)
pause

%% Neekvidistantn data - pevzorkovan pomoc interpolace
Ts = round(median(T)*10)/10;
ti = (floor(t(1)/Ts)*Ts:Ts:ceil(t(N)/Ts)*Ts)';
Ni = length(ti);
% Vbr interpolan metody
kk = menu('Vbr interpolan metody','Linern','Nejbli okol',...
    'Kubick splajnov','Po stech kubick Hermitovsk');
switch kk
    case 1
        metoda = 'linear';
    case 2
        metoda = 'nearest';
    case 3
        metoda = 'spline';
    case 4
        metoda = 'cubic';
end
% interpolace signlu na ekvidistantn
qi = interp1(t,q,ti,metoda); 
qi(1) = (q(2)-q(1))/(t(2)-t(1))*(ti(1)-t(1))+q(1);
qi(Ni) = (q(N)-q(N-1))/(t(N)-t(N-1))*(ti(Ni)-t(N-1))+q(N-1);

figure(8), hold on, grid on
plot(t,q,'b',ti,qi,'r')
switch jazyk
    case 1
        title('Namen a interpolovan data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Namen data','Interpolovan data','Location','Best')
    case 2
        title('Measured and interpolated data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Interpolated data','Location','Best')
end
pause

%% Odstrann stacionrn sloky signlu
Ni = length(ti);
value = zeros(Ni,1);
term = ones(Ni,1);
Qinf = mean(qi(end-100:end));
k = 0;
while norm(term) > 1024*eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*Dx/L^2*ti)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa = Qinf*(1-8/pi^2*value);
qid = qi-qa;
qid = qid-mean(qid);

%% Diskrtn Fourierova transformace
NFFT = 2^nextpow2(Ni); % Next power of 2 from length of q
Q = fft(qid,NFFT)/Ni;
f = 1/2/Ts*linspace(0,1,NFFT/2+1);

%  Frekvenn spektrum namench dat
figure(9), hold on, grid on
plot(f,2*abs(Q(1:NFFT/2+1))) 
switch jazyk
    case 1
        title('Amplitudov spektrum namench dat')
        xlabel('Frekvence [Hz]')
        ylabel('Amplituda')
    case 2
        title('Amplitude spectrum of measured data')
        xlabel('Frequency [Hz]')
        ylabel('Amplitude')
end
pause

%  Detailn frekvenn spektrum namench dat
figure(10), hold on, grid on
plot(f,2*abs(Q(1:NFFT/2+1))) 
set(gca,'XLim',[0,xmax]);
switch jazyk
    case 1
        title('Amplitudov spektrum namench dat')
        xlabel('Frekvence [Hz]')
        ylabel('Amplituda')
    case 2
        title('Amplitude spectrum of measured data')
        xlabel('Frequency [Hz]')
        ylabel('Amplitude')
end
pause

%% Nastaven Butterworthova filtru
% d Butterworthova filtru
n = 4;
% zlomov frekvence
cutoff0 = 0.5;
% filtrace signlu
[b,a] = butter(n,cutoff0);
qf = filtfilt(b,a,qi);

% zobrazen namench a filtrovanch dat
figure(11), hold on, grid on
plot(to,qo,'b')
plot(ti,qf+posun,'r')
switch jazyk
    case 1
        title('Namen a hrub filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q')
        legend('Namen data','Hrub filtrovan data','Location','Best')
    case 2
        title('Measured and roughly filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Roughly filtered data','Location','Best')
end
pause

% zobrazen potku men
% redukce rozsahu dat
kk = 0.1;
figure(12), hold on, grid on
plot(to(1:fix(kk*end)),qo(1:fix(kk*end)),'b')
plot(ti(1:fix(kk*end)),qf(1:fix(kk*end))+posun,'r')
switch jazyk
    case 1
        title('Namen a hrub filtrovan data - zatek')
        xlabel('as [t]'), ylabel('Poloha q')
        legend('Namen data','Hrub filtrovan data','Location','Best')
    case 2
        title('Measured and roughly filtered data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Roughly filtered data','Location','Best')
end
pause


%% Zptn pevzorkovn dat
% zobrazen namench a filtrovanch dat
figure(13), hold on, grid on
plot(to,qo,'b')
qs = interp1(ti,qf,t); 
qs(1) = mean(qs(2:11)); qs(N) = mean(qs(N-11:N-1));
plot(to,qs+posun,'r')
switch jazyk
    case 1
        title('Namen a zptn pevzorkovan filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Namen data','Zptn pevzorkovan filtrovan data','Location','Best')
    case 2
        title('Measured and back-resampled filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Back-resampled filtered data','Location','Best')
end
pause

%% Hledn mezn frekvence v celm rozsahu
cutoff = cutoff0;
dcutoff = 10^fix(log10(0.1*cutoff));

figure(14), hold on, grid on
plot(t,q,'b')
switch jazyk
    case 1
        title('Vbr mezn frekvence v celm rozsahu men')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
    case 2
        title('Selection of cutoff frequency in the whole measurement range')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
end

postup = 1;
while postup > 0
    % filtrace signlu
    [b,a] = butter(n,cutoff);
    qf = filtfilt(b,a,qi);
    qs = interp1(ti,qf,t); 
    qs(1) = mean(qs(2:11)); qs(N) = mean(qs(N-11:N-1));
    h1 = plot(t,qs,'r');
    switch jazyk
        case 1
            legend('Namen data','Filtrovan data','Location','Best')
        case 2
            title('Selection of cutoff frequency in the whole measurement range')
    end
    ss = sqrt(sum((q-qs).^2));
    switch jazyk
        case 1
            h2 = text(0.05,0.05,...
                ['Mezn frekvence filtru = ',num2str(cutoff)],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.50,0.05,...
                ['Krok zmny frekvence = ',num2str(dcutoff)],...
                'BackGroundColor','w','Color','r','Units','normalized');
        case 2
            h2 = text(0.05,0.05,...
                ['Filter cutoff frequency = ',num2str(cutoff)],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.50,0.05,...
                ['Cutoff frequency change = ',num2str(dcutoff)],...
                'BackGroundColor','w','Color','r','Units','normalized');
    end
    postup = menu('Dal postup','Zmenen mezn frekvence o krok',...
        'Zvten mezn frekvence o krok','Zmenen kroku na desetinu',...
        'Zvten kroku na desetinsobek','Konec');
    if postup == 1
        cutoff = cutoff-dcutoff;
            if cutoff <= eps
                cutoff = dcutoff;
            end    
    elseif postup == 2
        cutoff = cutoff+dcutoff;
            if cutoff >= 1
                cutoff = 1;
            end    
    elseif postup == 3
        dcutoff = 0.1*dcutoff;
    elseif postup == 4
        dcutoff = 10*dcutoff;
    elseif postup == 5 | postup == 0
        break
    end
    delete(h1);
    delete(h2);
    delete(h4);
end

%% Ladn hodnoty mezn frekvence v okn
okno = menu('Ladn v okn','Dal ladn','Konec');    
format long
while okno == 1
    disp(' ')
    k1 = input('Zatek okna (0-1): ');
    if isempty(k1)
        k1=0;
    end;
    k2 = input('Konec   okna (0-1): ');
    if isempty(k2)
        k2=1;
    end;
    if gcf == h
        close(h)
    end
    h = figure(15); hold on, grid on
    h1 = plot(t(1+fix(k1*end):fix(k2*end)),q(1+fix(k1*end):fix(k2*end)),'b');
    switch jazyk
        case 1
            title('Vbr mezn frekvence v sti men')
            xlabel('as [t]'), ylabel('Poloha q [mm]')
        case 2
            title('Selection of cutoff frequency in a part of measurement range')
            xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
    end
    postup = 1;
    while postup > 0
        % filtrace signlu
        [b,a] = butter(n,cutoff);
        qf = filtfilt(b,a,qi);
        qs = interp1(ti,qf,t);
        qs(1) = mean(qs(2:11)); qs(N) = mean(qs(N-11:N-1));
        h2 = plot(t(1+fix(k1*end):fix(k2*end)),qs(1+fix(k1*end):fix(k2*end)),'r');
        switch jazyk
            case 1
                legend('Namen data','Filtrovan data','Location','Best')
            case 2
                legend('Measured data','Filtered data','Location','Best')
        end
        hh = get(gca);
        XX = hh.XLim;
        YY = hh.YLim;
        pos1 = XX(1)+0.5*(XX(2)-XX(1));
        pos2 = YY(1)+0.1*(YY(2)-YY(1));
        pos3 = YY(1)+0.05*(YY(2)-YY(1));
        ss = sqrt(sum((q-qs).^2));
        switch jazyk
            case 1
                h3 = text(0.05,0.05,...
                    ['Mezn frekvence filtru = ',num2str(cutoff)],...
                    'BackGroundColor','w','Color','r','Units','normalized');
                h5 = text(0.50,0.05,...
                    ['Krok zmny frekvence = ',num2str(dcutoff)],...
                    'BackGroundColor','w','Color','r','Units','normalized');
            case 2
                h3 = text(0.05,0.05,...
                    ['Filter cutoff frequency = ',num2str(cutoff)],...
                    'BackGroundColor','w','Color','r','Units','normalized');
                h5 = text(0.50,0.05,...
                    ['Cutoff frequency change = ',num2str(dcutoff)],...
                    'BackGroundColor','w','Color','r','Units','normalized');
        end
        postup = menu('Dal postup','Zmenen mezn frekvence','Zvten mezn frekvence',...
            'Zmenen kroku','Zvten kroku','Konec');
        if postup == 1
            cutoff = cutoff-dcutoff;
            if cutoff <= eps
                cutoff = dcutoff;
            end
        elseif postup == 2
            cutoff = cutoff+dcutoff;
            if cutoff >= 1
                cutoff = 1;
            end
        elseif postup == 3
            dcutoff = 0.1*dcutoff;
        elseif postup == 4
            dcutoff = 10*dcutoff;
        elseif postup == 5 | postup == 0
            break
        end
        delete(h2);
        delete(h3);
        delete(h5);
    end
    okno = menu('Pokraovn','Dal okno','Konec');
end
format short

%% Zobrazen interpolovanch a filtrovanch dat
% Ekvidistantn interpolovan data 
figure(16), hold on, grid on
plot(ti,qi,'b')
plot(ti,qf,'r')
switch jazyk
    case 1
        title('Interpolovan men a filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Interpolovan men data','Filtrovan data','Location','Best')
    case 2
        title('Interpolated measured and filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Interpolated measured data','Filtered data','Location','Best')
end
pause

% Ekvidistantn interpolovan data - potek men
figure(17), hold on, grid on
kk = 0.125;
plot(ti(1:fix(kk*end)),qi(1:fix(kk*end)),'b')
plot(ti(1:fix(kk*end)),qf(1:fix(kk*end)),'r')
switch jazyk
    case 1
        title('Interpolovan men a filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Interpolovan men data','Filtrovan data','Location','Best')
    case 2
        title('Interpolated measured and filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Interpolated measured data','Filtered data','Location','Best')
end
pause

% Namen data s neekvidistantnm vzorkovnm
figure(18), hold on, grid on
plot(to,qo,'b')
plot(to,qs+posun,'r')
switch jazyk
    case 1
        title('Namen a zptn pevzorkovan filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Namen data','Zptn pevzorkovan filtrovan data','Location','Best')
    case 2
        title('Measured and back-resampled filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Back-resampled filtered data','Location','Best')
end
pause

% Namen data s neekvidistantnm vzorkovnm - potek men
figure(19), hold on, grid on
plot(to(1:fix(kk*end)),qo(1:fix(kk*end)),'b')
plot(to(1:fix(kk*end)),qs(1:fix(kk*end))+posun,'r')
switch jazyk
    case 1
        title('Namen a zptn pevzorkovan filtrovan data')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Namen data','Zptn pevzorkovan filtrovan data','Location','Best')
    case 2
        title('Measured and back-resampled filtered data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Back-resampled filtered data','Location','Best')
end
pause

%% Tisk vsledk do Excelu
disp(' ')
disp('Probh zpis vsledk do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
warning off MATLAB:xlswrite:AddSheet
header = {'Time','Measured','Filtered','Model1','Model2','Model3',...
    'Model4';'[s]','[mm]','[mm]','[mm]','[mm]','[mm]','[mm]'};
[status, message] = xlswrite(xlsdatsoubor,header,'Results','A1');
if strcmp(message.message,'Added specified worksheet.')
    disp(['Do souboru ', xlsdatsoubor, ' pidn list Results!!!'])
    disp(' ')
end
[status, message] = xlswrite(xlsdatsoubor,[to,qo,qs],'Results','A3');
if status == 1
    disp(['Do souboru ', xlsdatsoubor, ' spn zapsno ', ...
        num2str(length(to)), ' dk!!!'])
    disp(' ')
else
    disp(['Zpis dat do souboru ', xlsdatsoubor, ' nebyl spn!!!'])
    return
end

xlswrite(xlsdatsoubor,to,'List2','A3');
xlswrite(xlsdatsoubor,qo,'List2','B3');
xlswrite(xlsdatsoubor,qs+posun,'List2','C3');

%% Parametry optimalizace
%  Metoda prunho mnohostnu fminsearch
disp(' ')
disp('Parametry optimalizace')
disp(' ')

OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',1000,'MaxIter',1000,...
    'TolX',Dx*eps,'TolFun',1024*eps);
fprintf('Maximln poet iterac            : %10d \n',OptSearch.MaxIter)
fprintf('Maximln poet vpotu funkce     : %10d \n',OptSearch.MaxFunEvals)
fprintf('Koncov kritrium zmny promnnch : %10.4e \n',OptSearch.TolX)
fprintf('Koncov kritrium zmny funkce     : %10.4e \n',OptSearch.TolFun)

%% Vbr intervalu optimalizace
figure(20), hold on, grid on
switch jazyk
    case 1
        title('Namen data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
plot(to,qo,'b')

i1 = 1;
i2 = No;
step = 100;
smer = 1;
postup = 1;
while postup > 0
    h = plot([to(i1),to(i2)],[qa(i1),qa(i2)]+posun,'ro',...
        'MarkerFaceColor','r','MarkerSize',10);
    h1 = text(0.6,0.25,...
        ['Horn mez = ',num2str(i2)],...
        'BackGroundColor','w','Color','r','Units','normalized');
    h2 = text(0.6,0.20,...
        ['Doln mez = ',num2str(i1)],...
        'BackGroundColor','w','Color','r','Units','normalized');
    h3 = text(0.6,0.15,...
        ['Krok = ',num2str(step)],...
        'BackGroundColor','w','Color','r','Units','normalized');
    h4 = text(0.6,0.10,...
        ['Smr = ',num2str(smer)],...
        'BackGroundColor','w','Color','r','Units','normalized');
    postup = menu('Dal postup','Zmna doln meze','Zmna horn meze',...
        'Zmna obou mez','Dvojnsobn krok','Polovin krok',...
        'Zmna smru kroku','Konec');
    if postup == 1
        i1 = max(i1+step,1);
    elseif postup == 2
        i2 = min(i2-step,No);
    elseif postup == 3
        i1 = max(i1+step,1);
        i2 = min(i2-step,No);
        if i1 > i2
            i1 = mean([i1,i2]);
            i2 = i1;
        end
    elseif postup == 4
        step = smer*min(2*abs(step),No);
    elseif postup == 5
        step = smer*max(abs(step)/2,1);
    elseif postup == 6
        smer = -smer;
        step = -step;
    elseif postup >= 7 | postup == 0
        postup = 0;
    end
    delete(h);
    delete(h1);
    delete(h2);
    delete(h3);
    delete(h4);
end
plot(to(i1:i2),qa(i1:i2)+posun,'ro',...
    'MarkerFaceColor','r','MarkerSize',10);
pause

%% No. 0 - Optimalizace hodnoty difuznho koeficientu D
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek namench a vypotench dat
%  .0 Jednorozmrov optimalizace 

disp(' ')
disp('Probh optimalizace!!!')
disp(' ')
format long e;
tStart=tic;
[D0,ObjFceMin0,ExitFlag,Output] = fminsearch(@ObjFun0,Dx,OptSearch);
tElapsed = toc(tStart);

fprintf('Vsledky D1-optimalizace mench dat\n \n')
fprintf('Difuzn koeficient : %10.4e [m2/s] \n',D0)
switch ExitFlag
    case 1
        fprintf('\nOptimum nalezeno spn za %10.4f s!!! \n',tElapsed)
    case 0
        disp('Dosaen maximln poet iterac!!!')
    case -1
        disp('Vpoet ukonen chybou v elov funkci!!!')
end

%% Zobrazen vsledk
value = zeros(N,1);
term = ones(N,1);
k = 0;
while norm(term) > eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*D0/L^2*t)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa0 = mean(qo(No-100:No))*(1-8/pi^2*value);
 
figure(21), hold on, grid on
plot(to,qo,'b')
plot(to,qa0,'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D1 optimalizovanho modelu')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D1 optimalizovanho modelu','Location','Best')
    case 2
        title('Measured and D1-optimized model fitted data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D1-optimized model fitted data','Location','Best')
end
pause

kk = 0.2;
figure(22), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'b')
plot([to(1:fix(kk*end))],[qa0(1:fix(kk*end))],'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D1 optimalizovanho modelu - zatek')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D1 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D1-optimized model data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D1-optimized model data','Location','Best')
end
pause

%% No.1 - Optimalizace hodnoty difuznho koeficientu D
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek zptn pevzorkovanch a vypotench dat
%  .1 Jednorozmrov optimalizace 
disp(' ')
disp('Probh optimalizace!!!')
disp(' ')
OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
    'TolX',Dx*eps,'TolFun',1e+2*eps);
tStart=tic;
[D1,ObjFceMin1,ExitFlag,Output] = fminsearch(@ObjFun1,Dx,OptSearch);
tElapsed = toc(tStart);

fprintf('Vsledky D1-optimalizace filtrovanch dat\n \n')
fprintf('Difuzn koeficient : %10.4e [m2/s] \n',D1)
switch ExitFlag
    case 1
        fprintf('\nOptimum nalezeno spn za %10.4f s!!! \n',tElapsed)
    case 0
        disp('Dosaen maximln poet iterac!!!')
    case -1
        disp('Vpoet ukonen chybou v elov funkci!!!')
end

%% Tisk vsledk do Excelu
value = zeros(N,1);
term = ones(N,1);
k = 0;
while norm(term) > eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*D1/L^2*t)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa1 = qs(N)*(1-8/pi^2*value)+posun;

disp(' ')
disp('Probh zpis vsledk do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
xlswrite(xlsdatsoubor,qa1,'List2','D3');

% Zobrazen vsledk
figure(23), hold on, grid on
plot(to,qo,'b')
plot(to,qa1,'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D1 optimalizovanho modelu')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D1 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D1-optimized model fitted data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D1-optimized model fitted data','Location','Best')
end
pause

kk = 0.2;
figure(24), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'b')
plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D1 optimalizovanho modelu - zatek')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D1 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D1-optimized model data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D1-optimized model data','Location','Best')
end
pause

%% No.2 - Optimalizace hodnoty difuznho koeficientu D a 
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek filtrovanch a namench dat
%  .2 Dvourozmrov optimalizace 
disp(' ')
disp('Probh optimalizace!!!')
disp(' ')
Q0 = q(N);
x0 = [Dx,Q0];
OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
    'TolX',Dx*eps,'TolFun',1e+2*eps);
tStart=tic;
[x,ObjFceMin2,ExitFlag,Output] = fminsearch(@ObjFun2,x0,OptSearch);
D2 = x(1);
Q2 = x(2);
tElapsed = toc(tStart);

fprintf('Vsledky D2-optimalizace filtrovanch dat\n \n')
fprintf('Difuzn koeficient : %10.4e [m2/s] \n',D2)
fprintf('Ustlen hodnota   : %10.4e [mm] \n',Q2)
switch ExitFlag
    case 1
        fprintf('\nOptimum nalezeno spn za %10.4f s!!! \n',tElapsed)
    case 0
        disp('Dosaen maximln poet iterac!!!')
    case -1
        disp('Vpoet ukonen chybou v elov funkci!!!')
end


%% Tisk vsledk do Excelu
value = zeros(N,1);
term = ones(N,1);
k = 0;
while norm(term) > eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*D2/L^2*t)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa2 = Q2*(1-8/pi^2*value)+posun;

disp(' ')
disp('Probh zpis vsledk do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
[status, message] = xlswrite(xlsdatsoubor,qa2,'Results','E3');
if status == 1
    disp(['Do souboru ', xlsdatsoubor, ' spn zapsno ', ...
        num2str(length(qa2)), ' dk!!!'])
    disp(' ')
else
    disp(['Zpis dat do souboru ', xlsdatsoubor, ' nebyl spn!!!'])
    return
end

%% Zobrazen vsledk
figure(25), hold on, grid on
plot(to,qo,'b')
plot(to,qa2,'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D2 optimalizovanho modelu')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D2 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D2-optimized model fitted data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D2-optimized model fitted data','Location','Best')
end
pause

kk = 0.2;
figure(26), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'b')
plot([to(1:fix(kk*end))],[qa2(1:fix(kk*end))],'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D2 optimalizovanho modelu - zatek')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D2 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D2-optimized model data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D2-optimized model data','Location','Best')
end
pause


%% No.3 - Optimalizace hodnoty difuznho koeficientu D,  
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf
%  a zpodn signlu Td
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek filtrovanch a vypotench dat
%  .3 Trojrozmrov optimalizace 
disp(' ')
disp('Probh optimalizace!!!')
disp('ekejte, vpoet me trvat a nkolik minut!!!')
disp('Probh optimalizace!!!')
disp(' ')
Q0 = mean(q(N-100:N));
n0 = length(qs(abs((qs-qs(2))/qs(2))<1.0));
T0 = t(n0);
x0 = [Dx,Q0,T0];
OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
    'TolX',Dx*eps,'TolFun',1e+2*eps);
tStart=tic;
[x,ObjFceMin2,ExitFlag,Output] = fminsearch(@ObjFun3,x0,OptSearch);
tElapsed = toc(tStart);
D3 = x(1);
Q3 = x(2);
T3 = x(3);

fprintf('\nVsledky D3-optimalizace filtrovanch dat\n \n')
fprintf('Difuzn koeficient : %10.4e [m2/s] \n',D3)
fprintf('Ustlen hodnota   : %10.4e [mm] \n',Q3)
fprintf('Zpodn signlu   : %10.4e [s] \n',T3)
switch ExitFlag
    case 1
        fprintf('\nOptimum nalezeno spn za %10.4f s!!! \n',tElapsed)
    case 0
        disp('Dosaen maximln poet iterac!!!')
    case -1
        disp('Vpoet ukonen chybou v elov funkci!!!')
end

%% Tisk vsledk do Excelu
value = zeros(N,1);
term = ones(N,1);
k = 0;
idelay=find(t(t<T3),1,'last');
hh=[zeros(idelay,1);ones(N-idelay,1)];
tt=[t(t<T3);t(t>=T3)-T3];
while norm(term) > eps & k <= 1000
    term = hh.*exp(-(2*k+1)^2*pi^2*D3/L^2*tt)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa3 = hh.*(Q3*(1-8/pi^2*value))+posun;

disp(' ')
disp('Probh zpis vsledk do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
[status, message] = xlswrite(xlsdatsoubor,qa3,'Results','F3');
if status == 1
    disp(['Do souboru ', xlsdatsoubor, ' spn zapsno ', ...
        num2str(length(qa3)), ' dk!!!'])
    disp(' ')
else
    disp(['Zpis dat do souboru ', xlsdatsoubor, ' nebyl spn!!!'])
    return
end

%% Zobrazen vsledk
figure(27), hold on, grid on
plot(to,qo,'b')
plot(to,qa3,'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D3 optimalizovanho modelu')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Zptn pevzorkovan data','Data vypoten z D3 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D3-optimized model fitted data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D3-optimized model fitted data','Location','Best')
end
pause

kk = 0.2;
figure(28), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'b')
plot([to(1:fix(kk*end))],[qa3(1:fix(kk*end))],'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D3 optimalizovanho modelu - zatek')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D3 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D3-optimized model data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D3-optimized model data','Location','Best')
end
pause

%% No.4 - Optimalizace hodnoty difuznho koeficientu D,  
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf,
%  zpodn signlu Td a potenho daje q0
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek filtrovanch a vypotench dat
%  .4 tyrozmrov optimalizace 
disp(' ')
disp('Probh optimalizace!!!')
disp('ekejte, vpoet me trvat a nkolik minut!!!')
disp('Probh optimalizace!!!')
disp(' ')
Q0 = mean(qs(N-100:N));
n0 = length(qs(abs((qs-qs(2))/qs(2))<1.0));
T0 = t(n0);
q0 = mean(qs(1:10));
x0 = [Dx,Q0,T0,q0];
OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
    'TolX',Dx*eps,'TolFun',1e+2*eps);
tStart=tic;
[x,ObjFceMin2,ExitFlag,Output] = fminsearch(@ObjFun4,x0,OptSearch);
tElapsed = toc(tStart);
D4 = x(1);
Q4 = x(2);
T4 = x(3);
q4 = x(4);
fprintf('\nVsledky D4-optimalizace filtrovanch dat\n \n')
fprintf('Difuzn koeficient : %10.4e [m2/s] \n',D4)
fprintf('Ustlen hodnota   : %10.4e [mm] \n',Q4)
fprintf('Zpodn signlu   : %10.4e [s] \n',T4)
fprintf('Poten daj     : %10.4e [s] \n',q4)
switch ExitFlag
    case 1
        fprintf('\nOptimum nalezeno spn za %10.4f s!!! \n',tElapsed)
    case 0
        disp('Dosaen maximln poet iterac!!!')
    case -1
        disp('Vpoet ukonen chybou v elov funkci!!!')
end

%% Tisk vsledk do Excelu
value = zeros(N,1);
term = ones(N,1);
idelay=find(t(t<T4),1,'last');
hh=[zeros(idelay,1);ones(N-idelay,1)];
tt=[t(t<T4);t(t>=T4)-T4];
k = 0;
while norm(term) > eps & k <= 1000
    term = hh.*exp(-(2*k+1)^2*pi^2*D4/L^2*tt)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa4 = hh.*(Q4*(1-8/pi^2*value))+q4+posun;

disp(' ')
disp('Probh zpis vsledk do vstupn excelovsk tabulky!!!')
disp('ekejte, zpis dat me trvat nkolik destek vtein!!!')
disp(' ')
[status, message] = xlswrite(xlsdatsoubor,qa3,'Results','G3');
if status == 1
    disp(['Do souboru ', xlsdatsoubor, ' spn zapsno ', ...
        num2str(length(qa4)), ' dk!!!'])
    disp(' ')
else
    disp(['Zpis dat do souboru ', xlsdatsoubor, ' nebyl spn!!!'])
    return
end

% Zobrazen vsledk
figure(29), hold on, grid on
plot(to,qo,'b')
plot(to,qa4,'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D4 optimalizovanho modelu')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D4 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D4-optimized model fitted data')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D4-optimized model fitted data','Location','Best')
end
pause

kk = 0.2;
figure(30), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'b')
plot([to(1:fix(kk*end))],[qa4(1:fix(kk*end))],'r')
switch jazyk
    case 1
        title('Men data a data vypoten z D4 optimalizovanho modelu - zatek')
        xlabel('as [t]'), ylabel('Poloha q [mm]')
        legend('Men data','Data vypoten z D4 optimalizovanho modelu',...
        'Location','Best')
    case 2
        title('Measured and D4-optimized model data - beginning')
        xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','D4-optimized model data','Location','Best')
end


disp(' ')
disp('Vpoty ukoneny!!!')
disp(' ')

return

